import * as line from "@line/bot-sdk";
import GroupBuy from "./GroupBuy";

/**
 * Message
 */
export default class MessageClass {

	//#region private

	private bot: line.Client = null;

	//#endregion

	//#region Lifecycle

	constructor(bot: line.Client) {
		this.bot = bot;
	}

	//#endregion

	//#region Custom

	public async Message(event: any): Promise<void> {
		switch (event.message.type) {
			case "text": {
				return await this.Text(event);
			}

			default:
				break;
		}
	}

	public async Text(event: any): Promise<void> {
		switch (event.source.type) {
			case "group": {
				return await this.Group(event);
			}

			default:
				break;
		}
	}

	public async Group(event: any): Promise<any> {
		let groupId: string = event.source.groupId;
		// 團購 特別功能
		if ([process.env.toGroupBuy].includes(groupId)) {
			/** 訊息 */
			let msg: string[] = event.message.text.split(" ");
			/** 指令 */
			let instruction: string = msg[0];
			switch (instruction) {
				case "團購": {
					const messages: line.Message | line.Message[] = await GroupBuy.Run(event, msg, this.bot);
					if (messages) {
						return this.bot.replyMessage(event.replyToken, messages);
					}
				}

				default: {
					break;
				}
			}
		}
	}

	// Group(event) {
	// 	switch (event.source.groupId) {
	// 		case process.env.toYoutube: {
	// 			let messagereplace = event.message.text;
	// 			messagereplace.replace("【IFTTT】 \n", "");
	// 			let replyMsg = messagereplace;
	// 			let res_toUniversity = this.bot.pushMessage(process.env.toUniversity, replyMsg);
	// 			let res_toApex = this.bot.pushMessage(process.env.toApex, replyMsg);
	// 			break;
	// 		}

	// 		default:
	// 			break;
	// 	}
	// }

	//#endregion
}
